/*******************************************\
| * Ce programme est sous licence GNU GPL  * |
| * This software is under GNU/GPL licence  * |
| * * * * * * * * * * * * * * * * * * * * * * |
| * http://www.gnu.org/copyleft/gpl.html    * |
 \*******************************************/

/* Par Laurent Coustet <ed@zehome.com>
 * http://ed.zehome.com/                    
 * Made by Laurent Coustet <ed@zehome.com>
 */


#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "debug.h"

FILE *_Debug_Output = NULL;

void _DEBUG(int _debug_line, char *_debug_filename, 
            int _debug_priority,  const char *_debug_message, ...)
{
  /* arguments variables */
  char *z_format; /* thx dave */
  va_list ap;

  if (! _Debug_Output) { return; }
  
  va_start(ap, _debug_message);  

  /* message de priorite infrieure a notre prio, on vire */
  if (_debug_priority > DEBUGLEVEL)
    return;
    
  z_format = malloc(strlen(_debug_filename)+sizeof(int)*2+strlen(_debug_message)+31);
  sprintf(z_format, "[DEBUG PRIO %d][File: %s][Line: %d] %s", _debug_priority, _debug_filename, _debug_line, _debug_message);
  vfprintf(_Debug_Output, z_format, ap);
  fflush(_Debug_Output);
  free(z_format);
  va_end(ap);
  return;
}

void SetDebugFile(FILE *file) {
  _Debug_Output = file;
  return;
}
